{
  gROOT->ProcessLine(".L Macros/ana/TestNEBULA_ana.C");

  gStyle->SetOptStat(111111);
  gSystem->Load("libXMLParser.so");
  gSystem->Load("libanacore.so");
  gSystem->Load("libanasamurai.so");
  gSystem->Load("libananadeko.so");

  TArtEventStore *estore = new TArtEventStore();
  TArtRawEventObject *rawevent = new TArtRawEventObject();
  estore->Initialize(rawevent); 
  estore->Open("ridf/test.ridf");

  //NEBULA
  TArtNEBULAParameters *setup = new TArtNEBULAParameters();
  setup->LoadParameter("db/NEBULA.xml");
  TArtCalibNEBULA *mynebula= new TArtCalibNEBULA(setup);

  int neve = 0;
  while(estore->GetNextEvent() && neve<10000){
    std::cout << "\r AnaNEBULA: " << neve;

    mynebula->ReconstructData(rawevent);

    //val
    std::vector<Double_t> vadc, vtdc;
    std::vector<Double_t> vID;
    Double_t adcave = 0, tdcave = 0;

    Int_t NumNEBULA = mynebula->GetNumNEBULA();
    Int_t adccount, tdccount;
    for(int i=0; i < NumNEBULA; ++i){
      TArtNEBULA* pla = mynebula->GetNEBULA(i);
      Double_t adc = pla->GetRawADC();
      Double_t tdc = pla->GetRawTDC();
      vadc.push_back(adc);
      vtdc.push_back(tdc);
      vID.push_back(pla->GetID());
      if(adc >= 0 && adc < 4096){ 
	adcave += adc;
	++adccount;
      }
      if(tdc >= 0 && tdc < 4096){ 
	tdcave += tdc;
	++tdccount;
      }
    }
    if(adccount != 0) adcave /= adccount;
    if(tdccount != 0) tdcave /= tdccount;

    //fill hist
    //do not call processline in for loop(very slow)!!
    myfill();

    mynebula->ClearData();
    rawevent->Clear();
    ++neve;
  }
  std::cout << std::endl;

  return;
}
