
#include <iostream>
#include <limits>

#include "TThread.h"

#include "TArtEventStore.h"
#include "TArtStoreManager.h"

#include "TArtAnaLoop.hh"

TArtAnaLoop::EAnalysisState TArtAnaLoop::kAnalysisState;

void TArtAnaLoop::AnaLoop(char* filename, int eventnumber)
{
  std::cout << kAnalysisState << std::endl;
  if(kAnalysisState != SUSPEND){
    kAnalysisState = WORKING;
    neve = 0;

    estore = new TArtEventStore;
    estore->Open(filename);

    Construct();
  }else{
    kAnalysisState = WORKING;    
  }

  TThread *h = new TThread("h", TArtAnaLoop::handle, (void*)0);
  h->Run();
  while(1){
    ++neve;
    if(!estore->GetNextEvent() ||
       (!(eventnumber<0) && neve>eventnumber)){
      std::cout << std::endl;
      SuspendAction();
      std::cout << "\r Press ENTER to End Analysis. " << std::endl;
      h->Join();
      kAnalysisState = WORKING;
      break;
    }
    if(neve%100 == 0){
      std::cout << "\r Press ENTER to Suspend. "
		<< "Event Number: " << neve << std::flush;
    }

    Calculate();
    estore->ClearData();

    if(kAnalysisState == SUSPEND){
      std::cout << std::endl;
      SuspendAction();
      break;
    }
  }

  if(kAnalysisState != SUSPEND){
    Destruct();
    delete estore;
    delete TArtStoreManager::Instance();
  }
}

void *TArtAnaLoop::handle(void *ptr)
{
  std::cin.ignore( std::numeric_limits <std::streamsize> ::max(), '\n' );
  kAnalysisState = SUSPEND;

  return 0;
}
